Attribute VB_Name = "basShell"
Const SW_SHOW = 5
Const SHOW_OPENWINDOW = &H1
Const NORMAL_PRIORITY_CLASS = &H20

Type STARTUPINFO
    cb As Long
    lpReserved As Long
    lpDesktop As Long
    lpTitle As Long
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Byte
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type

Type PROCESS_INFORMATION
    hProcess As Long
    hThread As Long
    dwProcessId As Long
    dwThreadId As Long
End Type

Declare Sub SleepAPI Lib "kernel32" Alias "Sleep" (ByVal dwMilliseconds As Long)
Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" (ByVal lpApplicationName As String, ByVal lpCommandLine As String, ByVal lpProcessAttributes As String, ByVal lpThreadAttributes As String, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, ByVal lpEnvironment As String, ByVal lpCurrentDirectory As String, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
Declare Function GetExitCodeProcess Lib "kernel32" (ByVal hProcess As Long, lpExitCode As Long) As Long
Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpszOp As String, ByVal lpszFile As String, ByVal lpszParams As String, ByVal LpszDir As String, ByVal FsShowCmd As Long) As Long


'Run a DOS command, wait for it to finish, and return the result (DOS errorlevel)
Function ExecCmd(CmdString As String) As Long
    Dim sinfo As STARTUPINFO
    Dim pinfo As PROCESS_INFORMATION
    Dim success As Integer
    Dim ExitCode As Long
    sinfo.cb = Len(sinfo)
    sinfo.lpTitle = 0
    sinfo.lpReserved = 0
    sinfo.lpDesktop = 0
    sinfo.cbReserved2 = 0
    sinfo.lpReserved2 = 0
    sinfo.dwFlags = SHOW_OPENWINDOW
    sinfo.wShowWindow = SW_SHOW
    success = CreateProcess(vbNullString, CmdString, vbNullString, vbNullString, False, NORMAL_PRIORITY_CLASS, vbNullString, vbNullString, sinfo, pinfo)
    
    If success = 0 Then
        ExecCmd = -1
        Exit Function
    End If
    
    Do
        success = GetExitCodeProcess(pinfo.hProcess, ExitCode)
        If success = 0 Then
            ExecCmd = -2
            Exit Function
        End If
        DoEvents
        SleepAPI 55
    Loop Until ExitCode <> 259
    
    ExecCmd = ExitCode
    CloseHandle pinfo.hProcess
    CloseHandle pinfo.hThread
End Function


' Run an application or opens a file, folder, shortcut, email, or web page with the associated application
'
' Arguments:
'
' sFile           Name of the file, folder, or web page. May contain path substitutions
' sParameters     List of parameters if running an application (default = "")
' sOperation      Action verb for file associations. Right-click on the file in
'                 Windows Explorer to see the available options. For example:
'                 "edit"     Launch the editor for the document
'                 "explore"  Open Windows Explorer for the specified folder
'                 "find"     Open Windows Find dialog
'                 "open"     Open the file, folder, or application (default)
'                 "print"    Print the document
' sDefaultFolder  Default folder for the application to use. May contain path substitutions
' iMode           Request that the application window opens in a specific state:
'                 0  Hidden
'                 1  Normal (default)
'                 2  Minimized
'                 3  Maximized
'                 4  Recent size & position
'                 5  Current size & position
'                 7  Minimized (active window remains active)
'                 10 Default state
'
' Return Value:
'
' 0   No error
' 2   File not found
' 3   Path not found
' 5   Access denied
' 8   Out of memory
' 11  Corrupt exe file
' 26  Sharing violation
' 27  File association invalid
' 28  DDE timeout
' 29  DDE failed
' 30  DDE busy
' 31  No application associated with the file or operation
' 32  DLL not found
'
' Examples:
'
' Open Windows' Find dialog:             ExecEx("", "", "find");
' Open Windows Explorer for c:\windows:  ExecEx("c:\windows");
' Open a document:                       ExecEx("[data]:report.xls");
' Print a document:                      ExecEx("c:\doc\report.doc", "", "print");
' Open an application:                   ExecEx("notepad.exe");
' Open a web page:                       ExecEx("http://www.citect.com");
' Create an email message:               ExecEx("mailto:test@microsoft.com");
' Open a shortcut:                       ExecEx("c:\documents and settings\all users\start menu\My Application.lnk");
' Run a DOS command:                     ExecEx("cmd.exe", "/c <DOS command>");
Function ShellEx(ByVal sFile As String, Optional ByVal sParms As String = "", Optional ByVal sOperation As String = "", Optional ByVal sDefaultFolder As String = "", Optional ByVal nMode As Long = 1) As Long
    Dim nError As Long
    
    nError = ShellExecute(0, sOperation, sFile, sParms, sDefaultFolder, nMode)
    If nError > 32 Then nError = 0
    ShellEx = nError
End Function
